package applicative

import scala.language.higherKinds

trait Monad[F[_]] extends Applicative[F] {
  def flatMap[A, B](fa: F[A])(f: A => F[B]): F[B] = flatten(map(fa)(f))

  def flatten[A](fa: F[F[A]]): F[A] = flatMap(fa)(identity)
  override def map[A, B](fa: F[A])(f: A => B): F[B] = flatMap(fa)(f andThen unit)
  override def map2[A, B, C](fa: F[A], fb: F[B])(f: (A, B) => C): F[C] = flatMap(fa)(a => map(fb)(b => f(a,b)))
}
