package applicative

sealed trait Validated[+E, +A]
case class Valid[+A](a:A) extends Validated[Nothing, A]
case class Invalid[+E](head: E, tail: List[E] = List()) extends Validated[E, Nothing]

object Validated {
  implicit def validatedApplicative[E]: Applicative[Validated[E, +?]] = new Applicative[Validated[E,+?]] {
    def unit[A](a: A) = Valid(a)
    // add map2 or ap here
  }
}
