package applicative

import org.scalatest._
import testutil.PendingIfUnimplemented

class ValidatedSpec extends FlatSpec with Matchers with AppendedClues with PendingIfUnimplemented {
  "map2" should "accumulate errors" in {
    type VSI = Validated[String, Int]
    val valid1: VSI = Valid(1)
    val valid2: VSI = Valid(2)
    val invalidA: VSI = Invalid("A")
    val invalidB: VSI = Invalid("B")
    val invalidAB: VSI = Invalid("A", List("B"))
    val invalidABAB: VSI = Invalid("A", List("B", "A", "B"))

    val strErrorApplicative = implicitly[Applicative[Validated[String, +?]]]

    ??? //remove, when you have overridden map2 or ap

    strErrorApplicative.map2(valid1, valid2)((a, b) => a + b) shouldBe Valid(3)
    strErrorApplicative.map2(invalidA, valid2)((a, b) => a + b) shouldBe invalidA
    strErrorApplicative.map2(valid1, invalidB)((a, b) => a + b) shouldBe invalidB
    strErrorApplicative.map2(invalidA, invalidB)((a, b) => a + b) shouldBe invalidAB
    strErrorApplicative.map2(invalidAB, invalidAB)((a, b) => a + b) shouldBe invalidABAB
  }
}
